from types import StringTypes
from copy import deepcopy
from sys import stdin, stdout

class Node:
  def __init__(self, index = None):
    self.index = index
    self._incoming = []
    self._outgoing = []
  def copy(self):
    return Node(self.get_index())
  def set_index(self, index):
    self.index = index
  def get_index(self):
    return self.index
  def add_incoming(self, edge):
    self._incoming.append(edge)
  def incoming(self):
    for e in self._incoming:
      yield e
  def get_incoming(self, index):
    if index >= self.indegree():
      return None
    else:
      return self._incoming[index]
  def add_outgoing(self, edge):
    self._outgoing.append(edge)
  def outgoing(self):
    for e in self._outgoing:
      yield e
  def get_outgoing(self, index):
    if index >= self.outdegree():
      return None
    else:
      return self._outgoing[index]
  def indegree(self):
    return len(self._incoming)
  def outdegree(self):
    return len(self._outgoing)

class Edge:
  def __init__(self, source = None, target = None):
    self._source = source
    if isinstance(source, Node):
      source.add_outgoing(self)
    self._target = target
    if isinstance(target, Node):
      target.add_incoming(self)
  def copy(self, source = None, target = None):
    return Edge(source, target)
  def set_target(self, target):
    self._target = target
  def get_target(self):
    return self._target
  def set_source(self, source):
    self._source = source
  def get_source(self):
    return self._source
  # Delete edge from its source and target nodes
  def delete(self):
    if isinstance(self._source, Node):
      try:
        self._source._outgoing.remove(self)
      except:
        pass
    if isinstance(self._target, Node):
      try:
        self._target._incoming.remove(self)
      except:
        pass

class DiGraph:
  def __init__(self, infile = None):
    if infile != None:
      self.read(infile)
    else:
      self._V = []
  # Create a copy of graph
  def copy(self):
    G = DiGraph()
    for n in self.V():
      G._V.append(n.copy())
    for e in self.E():
      e.copy(G.get_node(e.get_source().get_index()), G.get_node(e.get_target().get_index()))
    return G
    G = deepcopy(self)
    for n in G.V():
      print n,
    print
    for n in self.V():
      print n,
    print
    exit(1)
    for e in G.E():
      print e.get_source(),
      e.set_source(G.get_node(e.get_source().get_index()))
      print e.get_source()
      e.set_target(G.get_node(e.get_target().get_index()))
    return G
  def number_of_nodes(self):
    return len(self._V)
  def number_of_edges(self):
    return sum([v.outdegree() for v in self._V])
  def read(self, infile = stdin):
    # Read next line from f, ignoring empty lines and removing comments;
    # return line as a list of tokens
    def nextline(f):
      # Convert s to a list of tokens, removing comments and returning
      # None if there are no non-white space symbols in s
      def cleanup_line(s):
        # Find next token in s
        def next_token(s):
          if s in ("", "\\"):
            # s is empty or consists solely of the escape character
            return "", None, False
          if s[0] == '\\':
            # Next symbol in s is escaped
            if s[1] == 'n':
              # Newline
              return s[2:], '\n', True
            if s[1] == 't':
              # Tab
              return s[2:], '\t', True
            # Other character; do no conversion
            return s[2:], s[1], True
          # Non-escaped symbol
          return s[1:], s[0], False
          ### End of next_token
        #
        t = []
        empty = True
        while s != "":
          s, u, v = next_token(s)
          if not v and u == "#":
            # Non-escaped # - start of comment, skip remainder of line
            break
          t.append((u, v))
          empty = empty and not v and u.isspace()
        if empty:
          return None
        else:
          return t
        ### End of cleanup_line
      #
      # Start by reading next line from f
      line = f.readline()
      if line != "":
        line = cleanup_line(line.strip())
        if line == None:
          # Line was empty or all comment - return next line instead
          return nextline(f)
        return line
      else:
        # End of file
        return None
      ### End of nextline
    # Convert a list of tokens to a list of white space separated elements
    def untoken(l):
      e = []
      i = 0
      j = 0
      while i < len(l):
        # Skipt stretches of non-escaped white spaces
        while j < len(l) and not l[j][1] and l[j][0].isspace():
          j += 1
        i = j
        # Determine next block of non-white spaces
        while i < len(l) and (l[i][1] or not l[i][0].isspace()):
          i += 1
        if i > j:
          # Insert this block in list of elements
          e.append("".join([a[0] for a in l[j:i]]))
        j = i
      return e
    # Interpret next element of s as an integer; if s is empty, read new line
    # from infile
    def next_int(s, infile):
      if s == []:
        s = untoken(nextline(infile))
      return int(s[0]), s[1:]
    # If infile is a name, assume it is a file name and open this file
    if type(infile) in StringTypes:
      infile = file(infile)
      close_at_exit = True
    else:
      close_at_exit = False
    # First line should be number of nodes
    n, s = next_int([], infile)
    self._V = []
    for i in xrange(n):
      self._V.append(Node(len(self._V)))
    # Rest of file should contain descriptions of each node
    for i in xrange(n):
      # First line of description should be outdegree of node
      m, s = next_int(s, infile)
      # Read each of the target nodes in turn
      for j in xrange(m):
        t, s = next_int(s, infile)
        Edge(self._V[i], self._V[t])
    # Check whether infile should be closed
    if close_at_exit:
      infile.close()
  def write(self, outfile = stdout):
    if type(outfile) in StringTypes:
      outfile = file(outfile, 'w')
      close_at_exit = True
    else:
      close_at_exit = False
    # Output number of nodes
    outfile.write("# Size of graph\n" + str(len(self._V)) + '\n')
    # Output nodes
    for v in self._V:
      outfile.write("\n# Node " + str(v.get_index()) + "\n#  Outdegree\n" + str(v.outdegree()) + "\n#  Outgoing edge destinations\n")
      for e in v.outgoing():
        outfile.write(str(e.get_target().get_index()) + '\n')
    if close_at_exit:
      outfile.close()
  def V(self):
    for v in self._V:
      yield v
  def E(self):
    for v in self._V:
      for e in v.outgoing():
        yield e
  # Reorder nodes in graph according to topological order; returns whether
  # graph is acyclic
  def topological_sort(self):
    # Initialise
    new_order = []
    count = len(self._V) * [0]
    for v in self.V():
      for e in v.incoming():
        if e.get_source() != v:
          count[v.get_index()] += 1
    top = []
    for i in xrange(len(count)):
      if count[i] == 0:
        top.append(i)
    # Now sort
    while top != []:
      # Handle the next node that has reached the top
      new_order.append(top[0])
      # Decrement count of remaining incoming edges for all vertices that
      # are reachable by an edge from current node
      for e in self._V[top[0]].outgoing():
        if e.get_target() != self._V[top[0]]:
          count[e.get_target().get_index()] -= 1
          if count[e.get_target().get_index()] == 0:
            top.append(e.get_target().get_index())
      top = top[1:]
    if len(new_order) == len(self._V):
      # Graph is acyclic - reorder nodes
      V = []
      for i in new_order:
        V.append(self._V[i])
      self._V = V
      for i in xrange(len(self._V)):
        self._V[i].set_index(i)
      return True
    else:
      # Graph contains at least one cycle
      return False
  def add_node(self):
    self._V.append(Node(len(self._V)))
    return self._V[-1]
  def add_edge(self, s, t):
    if isinstance(s, Node) and isinstance(t, Node) and s in self._V and t in self._V:
      e = Edge(s, t)
      return e
    else:
      return None
  def insert_node(self, node):
    node.set_index(len(self._V))
    self._V.append(node)
  def get_node(self, index):
    return self._V[index]
  # Find a path from s to t in graph; returns None if no such path exists
  def find_path(self, s, t):
    # Recursive function doing the job
    def __find_path(s, t, visited):
      if s == t:
        return []
      visited[s.get_index()] = True
      for e in s.outgoing():
        if not visited[e.get_target().get_index()]:
          p = __find_path(e.get_target(), t, visited)
          if p != None:
            return [e] + p
      return None
    visited = len(self._V) * [False]
    return __find_path(s, t, visited)
