#! /usr/local/bin/python
from sys import argv, stdin, stderr, exit
from wwdigraph import WeightedDiGraph

gfile = stdin
repeat = 100
if len(argv) > 1:
  ntranscript = int(argv[1])
  if len(argv) > 2:
    gfile = argv[2]
    if len(argv) > 3:
      repeat = int(argv[3])
else:
  stderr.write("Usage:\n" + argv[0] + " ntranscripts [asgfile [repeats]]\n")
  exit(1)

G = WeightedDiGraph(gfile)
G.topological_sort()
full = 0
ncover = 0
ecover = 0
for i in xrange(repeat):
  nodes = {}
  edges = {}
  for j in xrange(ntranscript):
    p = G.sample_path()
    if not nodes.has_key(p[0].get_source()):
      nodes[p[0].get_source()] = None
    for e in p:
      if not nodes.has_key(e.get_target()):
        nodes[e.get_target()] = None
      if not edges.has_key(e):
        edges[e] = None
  if len(edges) == G.number_of_edges():
    full += 1
  ncover += len(nodes) - 2
  ecover += len(edges)

print "P-value: %.2f" % (float(full) / float(repeat))
print "Average coverage is"
print " %.1f%% of all %d nodes" % (100 * float(ncover) / float(repeat) / float(G.number_of_nodes() - 2), G.number_of_nodes() - 2)
print " %.1f%% of all %d edges" % (100 * float(ecover) / float(repeat) / float(G.number_of_edges()), G.number_of_edges())
