% Returns an indicator matrix: transcript(i,j) = 1 iff exon fragment j is
% in transcript i.

sample_size = input('Enter number of transcripts to be generated: ');
if isempty(sample_size)
    sample_size = 1;
end

transcripts = zeros(sample_size, exons);
x = rand(sample_size, 2*exons);   % Some random numbers (up to 2*exons required per sample)

% Choose initiation exons
cum_I = [0 cumsum(pstart)];
I_choice = rand(sample_size,1);
initiation_exons = 0*I_choice;
for i = 1:length(I)
    initiation_exons(find(I_choice < cum_I(i+1) & I_choice >= cum_I(i))) = i;
end

for n = 1:sample_size
    k = 1;
    current_fragment = I(initiation_exons(n));
    transcripts(n,current_fragment) = 1;
    state = 1;  % 1 = "in"
    
    while ~(ismember(current_fragment,T) && state == 1)
        if state == 1
            transcripts(n,current_fragment) = 1;
            if x(n,k) < pout(current_fragment)
                state = 0;
            end
            k = k+1;
        end
        
        current_fragment = current_fragment + 1;
        
        if state == 0
            if x(n,k) < pin(current_fragment)
                state = 1;
            end
            k = k+1;
        end
    end
    
    transcripts(n,current_fragment) = 1;
end