% Returns an indicator matrix: transcript(i,j) = 1 iff exon fragment j is
% in transcript i.

sample_size = input('Enter number of transcripts to be generated: ');
if isempty(sample_size)
    sample_size = 1;
end

transcripts = zeros(sample_size, exons);
cum_S = cumsum(S,2);
x = rand(sample_size, exons);   % Some random numbers

% Choose initiation exons
cum_I = [0 cumsum(pstart)'];
I_choice = rand(sample_size,1);
initiation_exons = 0*I_choice;
for i = 1:length(I)
    initiation_exons(find(I_choice < cum_I(i+1) & I_choice >= cum_I(i))) = i;
end

for n = 1:sample_size
    k = 1;
    current_fragment = I(initiation_exons(n));
    transcripts(n,current_fragment) = 1;
        
    while ~ismember(current_fragment,T)
        current_fragment = find(cum_S(current_fragment,:) > x(n,k),1,'first');
        k = k+1;
        
	  transcripts(n,current_fragment) = 1;
    end
end