regionstart = [];
regionend = [];
Gam = [];
pvalue = [];
z = [];
curr_region_end = 0;    % Marker for the end of the current region we're testing

for i=1:exons
    if (i >= curr_region_end) & (pin(i) == 1 || ismember(i,I))
        curr_region_end = find(pin(i+1:end) == 1,1,'first');
        % Check whether region is big enough to test
        if curr_region_end > 2
            curr_region_end = curr_region_end + i;
            regionstart = [regionstart; i];
            regionend = [regionend; curr_region_end];
            L1 = 0; z1 = 0; % Likelihood and degrees of freedon
            L2 = 0; z2 = 0;
            % Go through region and calculate likelihoods
            for j=i:curr_region_end
                for k=i+1:curr_region_end
                    if W(j,k) > 0
                        L1 = L1 + W(j,k)*log(S(j,k));
                    end
                end
                
                if pin(j) > 0 && pin(j) < 1
                    L2 = L2 + sum(eW(:,j))*log(pin(j)) + (num_out(j-1)-sum(eW(:,j)))*log(1-pin(j));
                end
                if (pout(j) > 0 && pout(j) < 1) && (j < curr_region_end)
                    L2 = L2 + sum(eW(j,:))*log(pout(j)) + (num_in(j)-sum(eW(j,:)))*log(1-pout(j));
                end
                
                if sum(eW(j,:)) > 0
                    z1 = z1 + sum(inout_indicator(j+1:curr_region_end));
                end
            end
            
            z2 = sum(inout_indicator(i+1:curr_region_end)) + length(find(pout(i:curr_region_end-1) > 0));
            if z1-z2 > 0
                z = [z; z1 - z2];
                Gam = [Gam; 2*(L1 - L2)];
                pvalue = [pvalue; 100*(1 - chi2cdf(Gam(end),z(end)))];
            else
                regionstart(end) = []; regionend(end) = [];
            end
        end
    end
end

TotalGam = sum(Gam);
Totalz = sum(z);
Totalpvalue = 100*(1-chi2cdf(TotalGam,Totalz));
regionstart = [regionstart; 1];
regionstart = regionstart'
regionend = [regionend; exons];
regionend = regionend'
Gam = [Gam; TotalGam];
z = [z; Totalz];
pvalue = [pvalue; Totalpvalue];
pvalue = pvalue'